package cn.iocoder.yudao.module.mes.service.energydevice;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.mes.controller.admin.energydevice.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.energydevice.EnergyDeviceCheckRecordDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.energydevice.EnergyDeviceDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static cn.iocoder.yudao.framework.common.util.collection.CollectionUtils.convertMap;

/**
 * 能源设备 Service 接口
 *
 * @author 内蒙必硕
 */
public interface EnergyDeviceService {

    /**
     * 创建能源设备
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createEnergyDevice(@Valid EnergyDeviceSaveReqVO createReqVO);

    /**
     * 更新能源设备
     *
     * @param updateReqVO 更新信息
     */
    void updateEnergyDevice(@Valid EnergyDeviceSaveReqVO updateReqVO);

    /**
     * 删除能源设备
     *
     * @param id 编号
     */
    void deleteEnergyDevice(Long id);

    /**
     * 获得能源设备
     *
     * @param id 编号
     * @return 能源设备
     */
    EnergyDeviceRespVO getEnergyDevice(Long id);

    /**
     * 获得能源设备分页
     *
     * @param pageReqVO 分页查询
     * @return 能源设备分页
     */
    PageResult<EnergyDeviceDO> getEnergyDevicePage(EnergyDevicePageReqVO pageReqVO);

    // ==================== 子表（抄表记录） ====================

    /**
     * 获得抄表记录分页
     *
     * @param pageReqVO 分页查询
     * @param deviceId 能源设备Id
     * @return 抄表记录分页
     */
    PageResult<EnergyDeviceCheckRecordDO> getEnergyDeviceCheckRecordPage(PageParam pageReqVO, Long deviceId);

    /**
     * 创建抄表记录
     *
     * @param energyDeviceCheckRecord 创建信息
     * @return 编号
     */
    Long createEnergyDeviceCheckRecord(@Valid EnergyDeviceCheckRecordDO energyDeviceCheckRecord);

    /**
     * 更新抄表记录
     *
     * @param energyDeviceCheckRecord 更新信息
     */
    void updateEnergyDeviceCheckRecord(@Valid EnergyDeviceCheckRecordDO energyDeviceCheckRecord);

    /**
     * 删除抄表记录
     *
     * @param id 编号
     */
    void deleteEnergyDeviceCheckRecord(Long id);

	/**
	 * 获得抄表记录
	 *
	 * @param id 编号
     * @return 抄表记录
	 */
    EnergyDeviceCheckRecordDO getEnergyDeviceCheckRecord(Long id);
    List<EnergyDeviceDO> getList(Collection<Long> ids);

    default Map<Long, EnergyDeviceDO> getMap(Collection<Long> ids) {
        if (ids.isEmpty()) return new HashMap<>();
        return convertMap(getList(ids), EnergyDeviceDO::getId);
    }

    List<EnergyDeviceRespVO> queryDataRecords(EnergyDeviceConsumptionReqVO deviceConsumptionReqVO);


    List<HourEnergyValueVO> lastEnergyStatistics(Long deviceTypeId,Long orgId);

    List<DayEnergyValueVO> latestSevenDaysStatistics(Long deviceTypeId, Long orgId);
}